 DEFINE PAGE0, SPACE=ROM
 SEGMENT PAGE0

 extern defenitionpg1
 extern defenitionpg2
 extern defenitionpg3
 extern defenitionpg4

 include "ti83plus.inc"
 include "Statz-JumpTable.inc"

 db 080h, 00Fh
 db 000h, 000h, 000h, 000h
 db 080h, 012h
 db 001h, 004h
 db 080h, 021h
 db 001h
 db 080h, 031h
 db 001h
 db 080h, 048h
 db "Zstat", 000h, 000h, 000h
 db 080h, 081h
 db 005h
 db 080h, 090h
 db 003h, 026h, 009h, 004h
 db 00Eh, 08Dh, 06Bh, 03Ch
 db 002h, 00Dh, 040h, 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h
 db 0F5h, 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh, 0C9h
 db 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h, 02Ch, 0F4h, 02Dh
 db 073h, 0B4h, 027h, 0C4h, 0A0h, 072h, 054h, 0B9h, 0EAh, 07Ch
 db 03Bh, 0AAh, 016h, 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h
 db 042h, 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh, 0FCh
 db 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h
 db 080h, 07Fh
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h
 db 0
 jp StartApp

 dw defenitionpg1
 db 1
 dw defenitionpg2
 db 2
 dw defenitionpg3
 db 3
 dw defenitionpg4
 db 4

StartApp:
intrptEnPort	equ 3 ; interrupt enable (in/out) 
_ClrCursorHook	equ 4F69h
_PutAway		equ 403Ch
_LCD_DRIVERON 	equ 4978h 
onFlags 		equ 9 ;on key flags 
onRunning 		equ 3 ; 1=calculator is running 
iall equ 1011b
_AppInit		equ 404Bh
  ld      hl,AppVectors
  b_call  AppInit          ; install monitor vectors to catch putaways
  b_call RunIndicOff
;================================
;=        START SETUP           =
;================================
  ld a,0
  ld (curRow),a
  ld c,a
  res indicOnly, (IY+indicFlags)
  res indicRun, (IY+indicFlags)
;================================
RootM:
;================================
;Loads root menu
;================================
  ld a,0
  ld c,0
  ld (promptRow),a
  ld (promptCol),a
  ld (promptShift),a
  ld (curCol),a
  ld a,20
  ld (curRow),a
  jp setup
;=============================================================================================================
;                   Menu Analysis -Analizes information outputed by the menu subruitine
;=============================================================================================================

Manalysis:
  ld a,(curCol)  
  cp 180
  jr z,defs
  cp 184
  jp z,heyhey
  cp 185
  jp z,heyhey  
  cp 182
  jp z,nots
  cp 186
  jp z,thend
  cp 55
  jp M,heyhey
  cp 144
  jp M,heyhey
  cp 144
  jp P,notez
thend:
    AppOffErr                ; remove error handler to kill GOTO's
AppPutaway:
    res     plotLoc,(IY+plotFlags)      ; draws to display & buffer
    res     textWrite,(IY+sGrFlags)     ; small font written to dispaly
    b_call  ReloadAppEntryVecs          ; reload MON VECTORS with app loaders
    ld      (IY+textFlags),0
    bit     monAbandon,(IY+monFlags)    ; Is calc being turned off?
    jr      nz, turningOff                ; jump if turning off
    ld      a,iall
    out     (intrptEnPort),a
    b_call  LCD_DRIVERON
    set     onRunning,(IY+onFlags)
    ei
    b_jump  JForceCmdNoChar
turningOff:
    b_jump  PutAway                     ; don't switch to home screen                                      ; just do putaway of app
rawkeyHand:
dummy:
    ret
;   app's MON VECTOR table
AppVectors:
    dw      dummy
    dw      dummy
    dw      AppPutaway
    dw      dummy
    dw      dummy
    dw      dummy
    db      0
;   system error is being generated, kill the GOTO option.
NoGoTo:
    push    af
;   turning of the cursor hook is optional if you need to do it
    b_call  ClrCursorHook
    res     curAble,(IY+curFlags)
    pop     af
    res     e_editf,a
    b_jump  JError
defs:
  ld a,0
  ld (curRow),a
  ld (promptRow),a
  ld (curCol),a
  ld HL,0
  ld (HL),0
  ld c,0
  ld b,0
  jr setup

nots:
  ld a,16
  ld (curRow),a
  ld a,0
  ld (promptRow),a
  ld (curCol),a
  ld HL,0
  ld (HL),0
  ld c,0
  ld b,0
  jr setup
;=============================================================================================================
;=    MENU SUBRUTINE- RETURNS: cursorposition=cursor position; curRow=page in menu; select=(9*curRow)+Xmin                             = 
;=============================================================================================================  
  
  
setup:
  ld a,(curRow)  
  cp 20
  jp z,findpg
  cp 16
  jp z,findpg
  ld a,1
  ld (promptRow),a 
  ld a,0
  ld (curRow),a
  ld c,a
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line1
  jp disp

Start:
  ld a,0
  ld b,a
  jp cursor

done:
  ld a,(curRow)
  ld b,a
  add a,a
  add a,a
  add a,a
  add a,b
  ld c,a
  ld a,(promptRow)
  add a,c
  ld (curRow),a
  B_CALL ClrLCDFull
  ld HL,(curRow)
  ld (curCol),HL
  ld a,1
  ld (curRow),a  
  jp Manalysis

input:
  B_CALL GetKey
  cp kLeft
  jp z,RootM
  cp kDown
  jr z,down
  cp kEnter
  jr z,done
  cp kUp
  jr z,up  
  cp 154
  jp z,Aa
  cp 155
  jp z,Ba
  cp 156
  jp z,Ca
  cp 157
  jp z,Da
  cp 158
  jp z,Ea
  cp 159
  jp z,Fa
  cp 160
  jp z,Ga
  cp 161
  jp z,Ha
  cp 162
  jp z,Ia
  cp 163
  jp z,Ja
  cp 164
  jp z,Ka
  cp 165
  jp z,Llll
  cp 166
  jp z,Ma
  cp 167
  jp z,Na
  cp 168
  jp z,Oa
  cp 169
  jp z,Pa
  cp 170
  jp z,Qa
  cp 171
  jp z,Ra
  cp 172
  jp z,Sa
  cp 173
  jp z,Ta
  cp 174
  jp z,Ua
  cp 175
  jp z,Va
  cp 176
  jp z,Wa
  cp 177
  jp z,Xa
  cp 178
  jp z,Ya
  cp 179
  jp z,Za
  jr input
  jr input

up:
  ld a,(curRow)  
  cp 20
  jr z,mnup
  cp 16
  jr z,mnup
  ld a,c  
  cp 0
  jp z,dpage
  ld a,(promptRow)
  add a,-1
  ld (promptRow),a
  ld b,-7
  jp cursor

mnup:
  ld a,c
  cp 0
  jp z,mntop
  ld a,(promptRow)
  add a,-1
  ld (promptRow),a
  ld b,-7
  jp cursor

mntop:
  ld a,0
  ld (penCol),a
  ld (penRow),a
  PUSH HL
  ld hl,clr
  PUSH AF
  PUSH DE
  PUSH IX

VPutS54:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS53
  B_CALL VPutMap
  JR NC, VPutS54

VputS53:
  POP IX
  POP DE
  POP AF
  POP HL
  ld a,42
  ld c,a
  ld a,6
  ld (promptRow),a
  jp Start
  
down:
  ld a,(curRow)
  cp 14
  jr z,spdown
  cp 20
  jr z,mndown  
  cp 16
  jr z,mndown  
  ld a,c  
  cp 56
  jp z,upage
  ld a,(promptRow)
  add a,1
  ld (promptRow),a
  ld b,7
  jr cursor

spdown:
  ld a,c  
  cp 35
  jp z,upage
  ld a,(promptRow)
  add a,1
  ld (promptRow),a
  ld b,7
  jr cursor
    
mndown:
  ld a,c  
  cp 42
  jp z,mnbot
  ld a,(promptRow)
  add a,1
  ld (promptRow),a
  ld b,7
  jr cursor
  
mnbot:
  ld a,0
  ld (penCol),a
  ld a,42
  ld (penRow),a
  PUSH HL
  ld hl,clr
  PUSH AF
  PUSH DE
  PUSH IX

VPutS34:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS44
  B_CALL VPutMap
  JR NC, VPutS34

VputS44:
  ld a,0
  ld c,a
  ld (promptRow),a
  jp Start

cursor:
  ld a,0
  ld (penCol),a
  ld a,c
  ld (penRow),a
  PUSH HL
  ld hl,clr
  PUSH AF
  PUSH DE
  PUSH IX

VPutS3:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS4
  B_CALL VPutMap
  JR NC, VPutS3

VputS4:
  POP IX
  POP DE
  POP AF
  POP HL
  ld a,0
  ld (penCol),a
  ld a,(promptCol)
  cp 1
  jp z,thing
things:
  ld a,c
  add a,b
  ld c,a
  ld (penRow),a
  PUSH HL
  ld hl,pointer
  PUSH AF
  PUSH DE
  PUSH IX

VPutS5:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS6
  B_CALL VPutMap
  JR NC, VPutS5

VputS6:
  POP IX
  POP DE
  POP AF
  POP HL
  jp input

toppg:
  ld a,0
  ld (curRow),a
  jp findpg
  
upage:
  ld a,(curRow)
  cp 14
  jr z,toppg
  ld a,(curRow)
  add a,1
  ld (curRow),a
  jp findpg

botpg:
  ld a,14
  ld (curRow),a
  jp findpg
  
dpage:
  ld a,(curRow)
  cp 0
  jr z,botpg
  ld a,(curRow)
  add a,-1
  ld (curRow),a
  jp findpg

findpg:
  ld a,(curRow)
  cp 1
  jp z,pg2
  cp 0
  jp z,pg1
  cp 2
  jp z,pg3
  cp 3
  jp z,pg4
  cp 4
  jp z,pg5
  cp 5
  jp z,pg6
  cp 6
  jp z,pg7
  cp 7
  jp z,pg8
  cp 8
  jp z,pg9
  cp 9
  jp z,pg10
  cp 10
  jp z,pg11
  cp 11
  jp z,pg12
  cp 12
  jp z,pg13
  cp 13
  jp z,pg14
  cp 14
  jp z,pg15
  cp 20
  jp z,pg20
  cp 16
  jp z,pg16

pg1:                  ;Time to point out that I had this subruitine written in a slighly differnt order
  B_CALL ClrLCDFull   ;and it didnt work...why? no one knows, asm is just like thats but it took me forever
  ld a,-7             ;to figure out how to fix it, so...
  push HL             ; @%#$!! SHIT!!! COCK SUCKER!!!! there I'm done.
  LD HL,line1
  jp disp

pg2:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line2
  jp disp

pg3:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line3
  jp disp

pg4:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line4
  jp disp 
  
pg5:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line5
  jp disp
  
pg6:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line6
  jp disp
  
pg7:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line7
  jp disp
  
pg8:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line8
  jp disp
  
pg9:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line9
  jp disp

pg10:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line10
  jp disp  

pg11:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line11
  jp disp

pg12:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line12
  jp disp

pg13:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line13
  jp disp

pg14:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line14
  jp disp

pg15:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line15
  jp disp

pg20:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line20
  jp disp

pg16:
  B_CALL ClrLCDFull
  ld a,-7
  push HL
  LD HL,line21
  jp disp

disp:
  add a,7
  ld (penRow),a
  ld b,a
  ld a,7
  ld (penCol),a
  ld a,b
  PUSH AF
  PUSH DE
  PUSH IX
VPutS1:
  LD A,(HL)
  INC HL
  OR A
  JR Z, VputS2
  B_CALL VPutMap
  JR NC, VPutS1

VputS2:
  POP IX
  POP DE
  POP AF
  cp 56
  jp nz,disp
  pop HL
  ld a,0
  ld (penCol),a
  ld a,(promptCol)
  cp 1
  jp z,Start
  ld a,0
  ld c,a
  ld (promptRow),a
  jp Start
  
;============================================
;=               Data for menu              =
;============================================
  
pointer:
  db Sconvert,0

line21:
  db "The Law of Large Numbers",0
  db "The Central Limit Theorem",0
  db "Histogram ",ScapDelta," Bar Chart",0
  db Ssigma," percentages",0
  db "Variables' meanings",0
  db "Correlation-Causation",0
  db "THINK",0
  db 0
  db 0
line2:
  db "Categorical Data",0
  db "Central Limit Theorem",0
  db "Goodness of Fit Test",0
  db "Test of Association",0
  db "Test of Homogeneity",0
  db "Cluster Sampling",0
  db "Coefficient of Variation",0
  db "Complete Rand Design",0
  db "Composite Hypothesis",0

clr:
  db "      ",0

line1:
  db "Addition Rule",0
  db "Alternative Hypothesis",0
  db "Bar Chart",0
  db "Bayes' Theorem",0
  db "Bias",0
  db "Binomial Distribution",0
  db "Blinding",0
  db "Blocking",0
  db "Box and Whisker Plot",0

line3:
  db "Conditional Probability",0
  db "Confidence Interval",0
  db "Confidence Interval for...",0
  db "Confidence Level",0
  db "Confidence Limits",0
  db "Contingency Table",0
  db "Continuous Data",0
  db "Continuous Random Var",0
  db "Correlation Coefficient",0

line4:
  db "Critical Region",0
  db "Critical Value(s)",0
  db "Differencing",0
  db "Discrete Data",0
  db "Discrete Random Variable",0
  db "Dispersion",0
  db "Dot Plot",0
  db "Dummy Var.-regression",0
  db "Estimate",0

line5:
  db "Estimation",0
  db "Estimator",0
  db "Event",0
  db "Expected Frequencies",0
  db "Expected Value",0
  db "Experiment",0
  db "Experimental Design",0
  db "Extrapolation",0
  db "Factor",0

line6:
  db "Factorial Design",0
  db "Five-Number Summary",0
  db "Frequency Table",0
  db "Histogram",0
  db "Hypothesis Test",0
  db "Independent Events",0
  db "Independent Random Vars",0
  db "Independent Samples",0
  db "Interaction",0

line7:
  db "Inter-Quartile Range (IQR",0
  db "Interval Scale",0
  db "Irregular Component",0
  db "Least Squares",0
  db "Main Effect",0
  db "Matched Samples",0
  db "Median",0
  db "Mode",0
  db "Multiplication Rule",0

line8:
  db "Mutually Exclusive Events",0
  db "Nominal Data",0
  db "Non-linear Regression",0
  db "Normal Distribution",0
  db "Null Hypothesis",0
  db "Observed Frequencies",0
  db "One-sample t-test",0
  db "One-sided Test",0
  db "One-way Analysis-Variance",0

line9:
  db "Ordinal Data",0
  db "Outcome",0
  db "Outlier",0
  db "Paired Sample t-test",0
  db "Parameter",0
  db "Percentile",0
  db "Pie Chart",0
  db "Placebo",0
  db "Population",0

line10:
  db "Power",0
  db "Precision",0
  db "Probability",0
  db "Probability Density Functn",0
  db "Probability Distribution",0
  db "P-value",0
  db "Quantile",0
  db "Quartile",0
  db "Quota Sampling",0

line11:
  db "Random Sampling",0
  db "Random Variable",0
  db "Randomisation",0
  db "Randomised Block Design",0
  db "Range",0
  db "Regression Equation",0
  db "Regression Line",0
  db "Relative Frequency",0
  db "Residual",0

line12:
  db "Sample",0
  db "Sample Mean",0
  db "Sample Space",0
  db "Sample Variance",0
  db "Sampling Distribution",0
  db "Sampling Variability",0
  db "Scatter Plot",0
  db "Seasonal Component",0
  db "Significance Level",0

  line13:
  db "Simple Hypothesis",0
  db "Simple Random Sampling",0
  db "Skewness",0
  db "Standard Deviation",0
  db "Standard Error",0
  db "Statistic",0
  db "Statistical Inference",0
  db "Stem and Leaf Plot",0
  db "Stepwise Regression",0

line14:
  db "Stratified Sampling",0
  db "Symmetry",0
  db "Target Population",0
  db "Test Statistic",0
  db "Time Series",0
  db "Treatment",0
  db "Trend Component",0
  db "Two-sample t-test",0
  db "Two-sided Test",0

line15:
  db "2way Analysis-Variance",0
  db "Type I Error",0
  db "Type II Error",0
  db "Uniform Distribution",0
  db "Unit",0
  db "Variance",0
  db "     ",0
  db "     ",0
  db "     ",0

line20:
  db "Definitions",0
  db "Equations",0
  db "Notes",0
  db "Options",0
  db "History",0
  db "Info",0
  db "Quit",0
  db "     ",0
  db "     ",0 


;==============================================================================================================
;             End of Menu Subruitine
;==============================================================================================================
notez:
  B_CALL ClrLCDFull
  ld a,1
  ld (promptCol),a
  ld a,(curCol)
  jp gopg4
heyhey:
  B_CALL ClrLCDFull
  ld a,1
  ld (promptCol),a
  ld a,(curCol)
  add a,1
  cp 30
  jp M,gopg1
  cp 30
  jp z,gopg1
  cp 70
  jp M,gopg2
  cp 70
  jp z,gopg2
  cp 100
  jp M,gopg3
  cp 100
  jp z,gopg3
  jp gopg4
gopg1:
  B_CALL defenitionpg1
  jp RootM
gopg2:
  B_CALL defenitionpg2
  jp RootM
gopg3:
  B_CALL defenitionpg3
  jp RootM
gopg4:
  B_CALL defenitionpg4
  jp RootM

Aa:
  ld a,0
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,0
  ld (promptRow),a
  ld (curRow),a
  jp findpg
  
Ba:
  ld a,14
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld a,2
  ld c,0
  ld (promptRow),a
  ld a,0
  ld (curRow),a
  jp findpg

Ca:
  ld a,0
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,0
  ld (promptRow),a
  ld a,1
  ld (curRow),a
  jp findpg

Da:
  ld a,14
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,2
  ld (promptRow),a
  ld a,3
  ld (curRow),a
  jp findpg

Ea:
  ld a,56
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,8
  ld (promptRow),a
  ld a,3
  ld (curRow),a
  jp findpg

Fa:
  ld a,56
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,8
  ld (promptRow),a
  ld a,4
  ld (curRow),a
  jp findpg

Ga:
Ha:
  ld a,21
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,3
  ld (promptRow),a
  ld a,5
  ld (curRow),a
  jp findpg

Ia:
  ld a,35
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,5
  ld (promptRow),a
  ld a,5
  ld (curRow),a
  jp findpg

Ja:
Ka:
Llll:
  ld a,21
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,3
  ld (promptRow),a
  ld a,6
  ld (curRow),a
  jp findpg

Ma:
  ld a,28
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,4
  ld (promptRow),a
  ld a,6
  ld (curRow),a
  jp findpg

Na:
  ld a,7
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,1
  ld (promptRow),a
  ld a,7
  ld (curRow),a
  jp findpg

Oa:
  ld a,35
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,6
  ld (promptRow),a
  ld a,7
  ld (curRow),a
  jp findpg

Pa:
  ld a,21
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,3
  ld (promptRow),a
  ld a,8
  ld (curRow),a
  jp findpg

Qa:
  ld a,42
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,6
  ld (promptRow),a
  ld a,9
  ld (curRow),a
  jp findpg

Ra:
  ld a,0
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,0
  ld (promptRow),a
  ld a,10
  ld (curRow),a
  jp findpg

Sa:
  ld a,0
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,0
  ld (promptRow),a
  ld a,11
  ld (curRow),a
  jp findpg

Ta:
  ld a,14
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,2
  ld (promptRow),a
  ld a,13
  ld (curRow),a
  jp findpg

Ua:
  ld a,21
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,3
  ld (promptRow),a
  ld a,14
  ld (curRow),a
  jp findpg

Va:
Wa:
Xa:
Ya:
Za:
  ld a,28
  ld (promptShift),a
  ld a,1
  ld (promptCol),a
  ld c,0
  ld a,4
  ld (promptRow),a
  ld a,14
  ld (curRow),a
  jp findpg

thing:
  ld a,(promptShift)
  ld b,a
  ld a,0
  ld (promptShift),a  
  ld (promptCol),a
  ld a,0
  ld c,b
  ld b,a
  jp things
